package com.example.elytraboostnotplace;

import me.shedaniel.autoconfig.AutoConfig;
import me.shedaniel.autoconfig.serializer.JanksonConfigSerializer;
import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.fabricmc.fabric.api.event.player.UseBlockCallback;
import net.minecraft.client.MinecraftClient;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.FireworkRocketItem;
import net.minecraft.text.Text;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;

public class ElytraBoostNotPlaceModClient implements ClientModInitializer {
    private static ModConfig config;
    private static boolean lastToggleState = true;

    @Override
    public void onInitializeClient() {
        // 初始化配置
        AutoConfig.register(ModConfig.class, JanksonConfigSerializer::new);
        config = AutoConfig.getConfigHolder(ModConfig.class).getConfig();

        // TODO 注册快捷键，待修复
//        KeyBindingHelper.registerKeyBinding(config.toggleKey);

        // 每tick检查快捷键
        ClientTickEvents.END_CLIENT_TICK.register(client -> {
            if (config.toggleKey.wasPressed()) {
                config.modEnabled = !config.modEnabled;
                AutoConfig.getConfigHolder(ModConfig.class).save();

                // 显示通知
                if (client.player != null) {
                    String status = config.modEnabled ? "§a启用" : "§c禁用";
                    client.player.sendMessage(
                            Text.translatable(config.modEnabled ?
                                    "message.elytraboostnotplace.enabled" :
                                    "message.elytraboostnotplace.disabled"),
                            true
                    );
                }
            }
        });

        // 拦截右键点击方块事件
        UseBlockCallback.EVENT.register((player, world, hand, hitResult) -> {
            if (!shouldIntercept(player, hand)) {
                return ActionResult.PASS;
            }

            if (MinecraftClient.getInstance().interactionManager != null) {
                MinecraftClient.getInstance().interactionManager.interactItem(player, hand);
            }

            return ActionResult.FAIL;
        });
    }

    private boolean shouldIntercept(PlayerEntity player, Hand hand) {
        return config.modEnabled &&
                player.isGliding() &&
                player.getStackInHand(hand).getItem() instanceof FireworkRocketItem;
    }
}
